using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms;
using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Windows.Forms.Grid;

namespace BindingArrayList
{
    /// <summary>
    /// Summary description for Form1.
    /// </summary>
    public class Form1 : Form
    {
        #region "API Definition"

        private IContainer components;
        private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
        private ToolTip toolTip1;
        //private DataCollection dataSource;
        Timer t = new Timer();
        //BindingList<Data> list = new BindingList<Data>();
        //BindingList<Data> UpdatedList = new BindingList<Data>();

        BindingList<DataDict> list = new BindingList<DataDict>();
        BindingList<DataDict> UpdatedList = new BindingList<DataDict>();

        GenerateData gen = new GenerateData();

        #endregion

        #region "Constructor"

        public Form1()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();

            this.GridSettings();

            this.SampleCustomization();

        }
        #endregion

        #region "Sample Grid Settings"

        /// <summary>
        /// GridGrouping control getting started customization.
        /// </summary>
        private void GridSettings()
        {
            //used to set multiextended selection mode in gridgrouping control. 
            this.gridGroupingControl1.TableOptions.ListBoxSelectionMode = SelectionMode.MultiExtended;

            //used to set GridCaptionRowHeight.
            this.gridGroupingControl1.Table.DefaultCaptionRowHeight = 25;
            this.gridGroupingControl1.Table.DefaultColumnHeaderRowHeight = 30;
            this.gridGroupingControl1.Table.DefaultRecordRowHeight = 22;
            this.gridGroupingControl1.AllowProportionalColumnSizing = true;
            this.gridGroupingControl1.ShowGroupDropArea = true;

            //Navigate to other control using tabkey navigation
            this.gridGroupingControl1.WantTabKey = false;


        }

        #endregion

        #region "Sample Customization"
        /// <summary>
        /// implementation of the IBindingList for an array list.
        /// </summary>
        private void SampleCustomization()
        {

            Random rand = new Random();
            int r = rand.Next(15);
            //Generating datasourcce by using IBindingList.
            //Generating DataSource by using Random values.
            //for (int i = 0; i < 30; i++)
            //{
            //    list.Add(new Data(r.ToString(), "Category" + r.ToString(), "Desc" + r.ToString(), "field_1 " + r.ToString(), "field_2 " + r.ToString(),
            //        "field_3 " + r.ToString(), "field_4 " + r.ToString(), "field_5 " + r.ToString(), "field_6 " + r.ToString(), "field_7 " + r.ToString(), "field_8 " + r.ToString(), 
            //        "field_9 " + r.ToString(), "field_10 " + r.ToString(), "field_11 " + r.ToString(), "field_12 " + r.ToString(), "field_13 " + r.ToString(), "field_14 " + r.ToString(), 
            //        "field_15 " + r.ToString(), "field_16 " + r.ToString(), "field_17 " + r.ToString(), "field_18 " + r.ToString(), "field_19 " + r.ToString(), "field_20 " + r.ToString()));
            //    r = rand.Next(15);
            //}
            //Assigning datasource for grid.

            list = gen.MakeData();

            this.gridGroupingControl1.DataSource = list;//dataSource;

            gridGroupingControl1.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
            gridGroupingControl1.TableOptions.ListBoxSelectionMode = SelectionMode.One;
            gridGroupingControl1.TableOptions.SelectionBackColor = Color.RoyalBlue;
            gridGroupingControl1.TableOptions.SelectionTextColor = Color.White;

            for (int a = 0; a < 22; a++)
            {
                // all field bold
                gridGroupingControl1.TableDescriptor.Columns[a].Appearance.AnyRecordFieldCell.Font.Bold = true;

                if (a < 3)
                {
                    // league, home & away
                    gridGroupingControl1.TableDescriptor.Columns[a].Appearance.AnyRecordFieldCell.TextColor = Color.White;
                }
                else
                {
                    // others field align center
                    gridGroupingControl1.TableDescriptor.Columns[a].Appearance.AnyRecordFieldCell.TextColor = Color.Lime;
                    gridGroupingControl1.TableDescriptor.Columns[a].Appearance.AnyRecordFieldCell.HorizontalAlignment = Syncfusion.Windows.Forms.Grid.GridHorizontalAlignment.Center;
                }
            }

            gridGroupingControl1.TableDescriptor.Columns[3].Appearance.AnyRecordFieldCell.BackColor = Color.SkyBlue;
            gridGroupingControl1.TableDescriptor.Columns[3].Appearance.AnyRecordFieldCell.TextColor = Color.Black;
            gridGroupingControl1.TableDescriptor.Columns[6].Appearance.AnyRecordFieldCell.BackColor = Color.SkyBlue;
            gridGroupingControl1.TableDescriptor.Columns[6].Appearance.AnyRecordFieldCell.TextColor = Color.Black;

            gridGroupingControl1.TableDescriptor.Columns[9].Appearance.AnyRecordFieldCell.TextColor = Color.FromArgb(245, 144, 36);
            gridGroupingControl1.TableDescriptor.Columns[10].Appearance.AnyRecordFieldCell.TextColor = Color.FromArgb(245, 144, 36);

            gridGroupingControl1.TableDescriptor.Columns[11].Appearance.AnyRecordFieldCell.BackColor = Color.SkyBlue;
            gridGroupingControl1.TableDescriptor.Columns[11].Appearance.AnyRecordFieldCell.TextColor = Color.Black;
            gridGroupingControl1.TableDescriptor.Columns[14].Appearance.AnyRecordFieldCell.BackColor = Color.SkyBlue;
            gridGroupingControl1.TableDescriptor.Columns[14].Appearance.AnyRecordFieldCell.TextColor = Color.Black;

            gridGroupingControl1.TableDescriptor.Columns[17].Appearance.AnyRecordFieldCell.TextColor = Color.FromArgb(245, 144, 36);
            gridGroupingControl1.TableDescriptor.Columns[18].Appearance.AnyRecordFieldCell.TextColor = Color.FromArgb(245, 144, 36);


            gridGroupingControl1.TableControlCurrentCellStartEditing += gridGroupingControl1_TableControlCurrentCellStartEditing;
            gridGroupingControl1.GridVisualStyles = Syncfusion.Windows.Forms.GridVisualStyles.Office2010Black;

            GridConditionalFormatDescriptor gridCondFormat = new GridConditionalFormatDescriptor();
            gridCondFormat.Appearance.AnyRecordFieldCell.Interior = new Syncfusion.Drawing.BrushInfo(Color.Black);
            gridCondFormat.Appearance.AnyRecordFieldCell.Enabled = false;
            gridCondFormat.Expression = "[StyleId] = 1";

            GridConditionalFormatDescriptor gridCondFormat2 = new GridConditionalFormatDescriptor();
            gridCondFormat2.Appearance.AnyRecordFieldCell.Interior = new Syncfusion.Drawing.BrushInfo(Color.FromArgb(33, 38, 57));
            gridCondFormat2.Appearance.AnyRecordFieldCell.Enabled = false;
            gridCondFormat2.Expression = "[StyleId] = 2";

            gridGroupingControl1.TableDescriptor.ConditionalFormats.Add(gridCondFormat);
            gridGroupingControl1.TableDescriptor.ConditionalFormats.Add(gridCondFormat2);

            // issues on column size after tabledescriptor option was set
            gridGroupingControl1.TableModel.ColWidths.ResizeToFit(Syncfusion.Windows.Forms.Grid.GridRangeInfo.Table(), Syncfusion.Windows.Forms.Grid.GridResizeToFitOptions.IncludeHeaders);
            gridGroupingControl1.TableOptions.AllowSortColumns = false;
        }

        void gridGroupingControl1_TableControlCurrentCellStartEditing(object sender, GridTableControlCancelEventArgs e)
        {
            try
            {
                GridTableCellStyleInfo style = gridGroupingControl1.TableControl.GetTableViewStyleInfo(e.TableControl.CurrentCell.RowIndex, e.TableControl.CurrentCell.ColIndex);

                if (style.TableCellIdentity.TableCellType == GridTableCellType.RecordFieldCell || style.TableCellIdentity.TableCellType == GridTableCellType.AlternateRecordFieldCell)
                {
                    e.Inner.Cancel = true;
                }
            }
            catch (Exception ex)
            {

            }
        }
        #region events
        void Form1_Load(object sender, EventArgs e)
        {
            t.Start();
            t.Interval = 2000;
            t.Tick += t_Tick;
        }

        void t_Tick(object sender, EventArgs e)
        {
            this.UpdateDataSource();
        }
        #endregion

        private void UpdateDataSource()
        {
            Random rand = new Random();
            int r = rand.Next(15);
            UpdatedList = new BindingList<DataDict>();

            UpdatedList = gen.MakeData();
            this.gridGroupingControl1.DataSource = UpdatedList;//dataSource;
            //for (int i = 0; i < list.Count; i++)
            //{
            //    UpdatedList.Add(new Data(r.ToString(), "Category" + r.ToString(), "Desc" + r.ToString(), "field_1 " + r.ToString(), "field_2 " + r.ToString(),
            //        "field_3 " + r.ToString(), "field_4 " + r.ToString(), "field_5 " + r.ToString(), "field_6 " + r.ToString(), "field_7 " + r.ToString(), "field_8 " + r.ToString(),
            //        "field_9 " + r.ToString(), "field_10 " + r.ToString(), "field_11 " + r.ToString(), "field_12 " + r.ToString(), "field_13 " + r.ToString(), "field_14 " + r.ToString(),
            //        "field_15 " + r.ToString(), "field_16 " + r.ToString(), "field_17 " + r.ToString(), "field_18 " + r.ToString(), "field_19 " + r.ToString(), "field_20 " + r.ToString()));
            //    r = rand.Next(15);
            //}
            //for (int i = 0; i < UpdatedList.Count - 1; i++)
            //{
            //    Data d = UpdatedList[i] as Data;
            //    Data update = list[i] as Data;
            //    update.CategoryID = d.CategoryID;
            //    update.CategoryName = d.CategoryName;
            //    update.Description = d.Description;
            //}

        }

        #endregion

        #region "Designer Stuffs"

        #region Dispose

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        /// 
        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                if (components != null)
                {
                    components.Dispose();
                }
            }
            base.Dispose(disposing);
        }

        #endregion

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
            this.toolTip1 = new System.Windows.Forms.ToolTip(this.components);
            ((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
            this.SuspendLayout();
            // 
            // gridGroupingControl1
            // 
            this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
            this.gridGroupingControl1.Dock = System.Windows.Forms.DockStyle.Fill;
            this.gridGroupingControl1.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.gridGroupingControl1.Location = new System.Drawing.Point(0, 0);
            this.gridGroupingControl1.Name = "gridGroupingControl1";
            this.gridGroupingControl1.Size = new System.Drawing.Size(1689, 757);
            this.gridGroupingControl1.TabIndex = 0;
            this.gridGroupingControl1.TableDescriptor.Appearance.AnyCell.Font.Facename = "Segoe UI";
            this.gridGroupingControl1.TableDescriptor.Appearance.AnyCell.TextColor = System.Drawing.Color.FromArgb(((int)(((byte)(138)))), ((int)(((byte)(138)))), ((int)(((byte)(138)))));
            this.gridGroupingControl1.TableDescriptor.Appearance.AnyGroupCell.Borders.Bottom = new Syncfusion.Windows.Forms.Grid.GridBorder(Syncfusion.Windows.Forms.Grid.GridBorderStyle.Solid, System.Drawing.Color.FromArgb(((int)(((byte)(234)))), ((int)(((byte)(234)))), ((int)(((byte)(234))))), Syncfusion.Windows.Forms.Grid.GridBorderWeight.ExtraThin);
            this.gridGroupingControl1.TableDescriptor.Appearance.AnyGroupCell.Borders.Right = new Syncfusion.Windows.Forms.Grid.GridBorder(Syncfusion.Windows.Forms.Grid.GridBorderStyle.Solid, System.Drawing.Color.FromArgb(((int)(((byte)(234)))), ((int)(((byte)(234)))), ((int)(((byte)(234))))), Syncfusion.Windows.Forms.Grid.GridBorderWeight.ExtraThin);
            this.gridGroupingControl1.TableDescriptor.Appearance.AnyGroupCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.Color.FromArgb(((int)(((byte)(235)))), ((int)(((byte)(235)))), ((int)(((byte)(235))))));
            this.gridGroupingControl1.TableDescriptor.Appearance.AnyGroupCell.TextColor = System.Drawing.Color.FromArgb(((int)(((byte)(138)))), ((int)(((byte)(138)))), ((int)(((byte)(138)))));
            this.gridGroupingControl1.TableDescriptor.Appearance.AnyRecordFieldCell.Borders.Bottom = new Syncfusion.Windows.Forms.Grid.GridBorder(Syncfusion.Windows.Forms.Grid.GridBorderStyle.Solid, System.Drawing.Color.FromArgb(((int)(((byte)(234)))), ((int)(((byte)(234)))), ((int)(((byte)(234))))), Syncfusion.Windows.Forms.Grid.GridBorderWeight.ExtraThin);
            this.gridGroupingControl1.TableDescriptor.Appearance.AnyRecordFieldCell.Borders.Right = new Syncfusion.Windows.Forms.Grid.GridBorder(Syncfusion.Windows.Forms.Grid.GridBorderStyle.Solid, System.Drawing.Color.FromArgb(((int)(((byte)(234)))), ((int)(((byte)(234)))), ((int)(((byte)(234))))), Syncfusion.Windows.Forms.Grid.GridBorderWeight.ExtraThin);
            this.gridGroupingControl1.TableDescriptor.Appearance.AnySummaryCell.Borders.Right = new Syncfusion.Windows.Forms.Grid.GridBorder(Syncfusion.Windows.Forms.Grid.GridBorderStyle.Solid, System.Drawing.Color.FromArgb(((int)(((byte)(208)))), ((int)(((byte)(208)))), ((int)(((byte)(208))))), Syncfusion.Windows.Forms.Grid.GridBorderWeight.ExtraThin);
            this.gridGroupingControl1.TableDescriptor.Appearance.AnySummaryCell.Borders.Top = new Syncfusion.Windows.Forms.Grid.GridBorder(Syncfusion.Windows.Forms.Grid.GridBorderStyle.Solid, System.Drawing.Color.FromArgb(((int)(((byte)(208)))), ((int)(((byte)(208)))), ((int)(((byte)(208))))), Syncfusion.Windows.Forms.Grid.GridBorderWeight.ExtraThin);
            this.gridGroupingControl1.TableDescriptor.Appearance.AnySummaryCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.Color.FromArgb(((int)(((byte)(208)))), ((int)(((byte)(208)))), ((int)(((byte)(208))))));
            this.gridGroupingControl1.TableDescriptor.Appearance.ColumnHeaderCell.Font.Bold = true;
            this.gridGroupingControl1.TableDescriptor.Appearance.GroupCaptionCell.CellType = "ColumnHeader";
            this.gridGroupingControl1.TableDescriptor.TableOptions.ColumnHeaderRowHeight = 25;
            this.gridGroupingControl1.TableDescriptor.TableOptions.RecordRowHeight = 20;
            this.gridGroupingControl1.TableOptions.GridLineBorder = new Syncfusion.Windows.Forms.Grid.GridBorder(Syncfusion.Windows.Forms.Grid.GridBorderStyle.Solid, System.Drawing.Color.White);
            this.gridGroupingControl1.Text = "gridGroupingControl1";
            this.toolTip1.SetToolTip(this.gridGroupingControl1, "Implements ListChanged event to make the grid aware if any items are added\r\n or r" +
        "emoved and thus the grid can update itself automatically when the bound\r\ndata ch" +
        "anges.");
            this.gridGroupingControl1.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
            this.gridGroupingControl1.VersionInfo = "5.102.0.28";
            this.gridGroupingControl1.QueryCellStyleInfo += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventHandler(this.gridGroupingControl1_QueryCellStyleInfo);
            this.gridGroupingControl1.TableControlCellMouseHoverEnter += gridGroupingControl1_TableControlCellMouseHoverEnter;
            this.gridGroupingControl1.TableControlCellMouseHoverLeave += gridGroupingControl1_TableControlCellMouseHoverLeave;
            // 
            // toolTip1
            // 
            this.toolTip1.ShowAlways = true;
            // 
            // Form1
            // 
            this.ClientSize = new System.Drawing.Size(1689, 757);
            this.Controls.Add(this.gridGroupingControl1);
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.MinimumSize = new System.Drawing.Size(615, 330);
            this.Name = "Form1";
            this.ShowIcon = false;
            this.Text = "IBindingList";
            this.toolTip1.SetToolTip(this, "Implements ListChanged event to make the grid aware if any items are \r\nadded or r" +
        "emoved and thus the grid can update itself automatically when\r\n the bound data c" +
        "hanges.");
            this.Load += new System.EventHandler(this.Form1_Load);
            ((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
            this.ResumeLayout(false);

        }
        
        #endregion

        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            Application.EnableVisualStyles();
            Application.Run(new Form1());
        }

        #endregion

        int hoveredRowIndex, hoverColIndex;
        void gridGroupingControl1_TableControlCellMouseHoverLeave(object sender, GridTableControlCellMouseEventArgs e)
        {
            this.gridGroupingControl1.TableControl.InvalidateRange(GridRangeInfo.Cell(e.Inner.RowIndex, e.Inner.ColIndex));
        }
        private void gridGroupingControl1_TableControlCellMouseHoverEnter(object sender, GridTableControlCellMouseEventArgs e)
        {
            hoveredRowIndex = e.Inner.RowIndex;
            hoverColIndex = e.Inner.ColIndex;
            this.gridGroupingControl1.TableControl.InvalidateRange(GridRangeInfo.Cell(hoveredRowIndex, hoverColIndex));
        }
        private void gridGroupingControl1_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
        {
            try
            {
                // mouse over color
                Syncfusion.Windows.Forms.Grid.GridCurrentCell gcc = gridGroupingControl1.TableControl.CurrentCell;
                GridTableCellStyleInfo style = e.Style as GridTableCellStyleInfo;

                if (hoveredRowIndex == e.TableCellIdentity.RowIndex && hoverColIndex == e.TableCellIdentity.ColIndex)
                {
                    //Set the back color for the mouse hovered row.
                    e.Style.BackColor = Color.Goldenrod;
                    e.Style.TextColor = Color.Black;
                }

                // home / away team text color
                if (style != null && style.TableCellIdentity != null && style.TableCellIdentity.DisplayElement != null && style.TableCellIdentity.DisplayElement.GetRecord() != null && style.TableCellIdentity.Column != null)
                {
                    Syncfusion.Grouping.Record record = style.TableCellIdentity.DisplayElement.GetRecord();
                    string value = record["MyField_1"].ToString();

                    if (value.Length > 0)
                    {
                        if (style.TableCellIdentity.Column.Name == "MyField_1")
                        {
                            style.TextColor = Color.FromArgb(0, 255, 255);
                        }
                        else if (style.TableCellIdentity.Column.Name == "MyField_2")
                        {
                            style.TextColor = Color.FromArgb(255, 0, 0);
                        }

                    }
                }
            }
            catch (Exception ex)
            {

            }
        }
    }
}